#include "Pilha.h"
#include "Fila.h"
#include "Heap_.h"

#define MAX_N_VERTICES 100 
#define MAX_N_ARESTAS MAX_N_VERTICES*(MAX_N_VERTICES-1)/2

#define NULO -1
#define BRANCO -1
#define CINZA 0
#define PRETO 1

typedef struct NoLista {
        int id;
        float peso;
        struct NoLista *prox;
} NoLista;

typedef struct {
        NoLista *inicio;
} NoGrafo;

typedef struct {
   NoGrafo LAdj[MAX_N_VERTICES];
   int nVertices;
} Grafo;

void criarGrafo(Grafo*, int, int*);

void setNumVertices(Grafo*, int);

int getNumVertices(Grafo*);

void inserirAresta(Grafo*, int, int, float, int*);

int existeAresta(Grafo*, int, int, int*);

//void retirarAresta(Grafo*, int, int, int*);

int grauVertice(Grafo*, int, int*);

void imprimirGrafo(Grafo*);

void bfs(Grafo*, int, int[]);

void dfs_(Grafo*);

//void dfs(Grafo*, int, int[], int[], int[], int[], int*);

void iniciarDfs(Grafo*);

void classificarArestas_(Grafo*, char[][]);

void classificarArestas(Grafo*, int, int[], int[], int*, char[][]);

void iniciarClassificarArestas(Grafo*, char[][]);

void prim(Grafo*, int, int[]);
